#include <minigui.ch>
#include 'adodb.ch'

// Caja
/*
La caja tiene como funcion generar un resumen de comprobantes del dia, generar un listado y cerrar los comprobantes
Se hace una caja por usuario, pudiendo seleccionar y cerrar cada cual sus comprobantes.
Los comprobantes se cierran una vez que se imprime la caja, mientras tanto los comprobantes quedan activos.
*/
procedure proc202()
	local odata
	
	if iswindowdefined(form202)
		return
	endif
	
	With object (oData:=structure())
		:member("mae", Openrecordset(oConexion,"Select * from caja_maestro"))
		:member("aux", Openrecordset(oConexion,"Select * from caja_auxiliar"))
		:member("trm", Openrecordset(oConexion,"Select * from Transaccionesmaestro"))
		:member("tra", Openrecordset(oConexion,"Select * from Transaccionesauxiliar"))
		:member("soc", Openrecordset(oConexion,"Select * from socios"))
		:member("aItems",Carga_socios(:soc))
		:member("Fld", {'id','idMaestro','IdSocio','Boleta','Ingreso','Egreso'})
		:member("ColumnControls", {	{'TEXTBOX','NUMERIC'},;
									{'TEXTBOX','NUMERIC'},;
									{'TEXTBOX','NUMERIC'},;
									{'TEXTBOX','NUMERIC'},;
									{'TEXTBOX','NUMERIC','999,999'},;
									{'TEXTBOX','NUMERIC','999,999'}})
		:member("Headers",{'Id','Comprobante','Socio','Boleta','Ingreso','Egreso'})
		:member("Items", {0,0,0,0,0,0})
		:member("Widths",{0,100,80,80,80,80})
		:member("justify", {0,1,1,1,1,1})
		:member("nEdit", 0 )
	End With
	
	load window form202
	form202.center
	ON KEY ESCAPE OF form202 ACTION Cerrar_Comprobante(odata)
	activate window form202
	
return

static procedure puntero(n,odata)
	With Object oData
		if :Mae:Recordcount > 0
			do case
			case n = 1
				:Mae:Movefirst()
			case n = 2
				:Mae:MovePrevious()
				if :Mae:bof()
					:Mae:MoveFirst()
				Endif
			case n = 3
				:Mae:MoveNext()
				if :Mae:eof()
					:Mae:MoveLast()
				Endif
			case n = 4
				:Mae:MoveLast()
			endcase
			estado_control(0,odata)
			Muestra_datos(odata)
		endif
	End With
return

static procedure estado_control(n,odata)
	if n > 1
		if oData:Mae:recordcount > 0
			if odata:mae:fields('estado'):value <> 0
				msgstop('No se puede editar un documento')
				return
			endif
		endif
	endif
	form202.grid_1.enabled		:= if( n >0, .T., .F. )
	form202.text_3.enabled		:= .f.
	form202.text_4.enabled		:= .f.
	form202.text_5.enabled		:= .f.
	form202.datepicker_1.enabled:= if( n >0, .T., .F. )
	if oData:nEdit = 1
		form202.datepicker_1.enabled:= if(n=0, .F., .T.)
		form202.text_1.value	:= 0
		form202.text_2.value	:= ""
		form202.datepicker_1.value := date()
		form202.grid_1.deleteallitems
		form202.datepicker_1.setfocus
	elseif odata:nedit = 2
		form202.grid_1.setfocus
	endif
return

static procedure muestra_datos(odata)
	local aEstado := {'Activo','Cerrado','Nulo'}
	local nIngreso := 0, nEgreso := 0
	form202.grid_1.deleteallitems
	With Object oData
		*- Encabezado del documento
		form202.text_1.value		:= :mae:fields('idCaja'):value
		form202.text_2.value		:= obtener_responsable(:mae:fields('idResponsable'):value)
		form202.datepicker_1.value	:= stod(:mae:fields('fecha_emision'):value)
		form202.label_5.value 		:= 'Estado Documento : '+aEstado[:Mae:fields('estado'):Value +1]
		form202.datepicker_1.enabled:= .f.
		*- Detalle del documento
		:aux:filter="idCaja="+ToString(:Mae:fields('IdCaja'):value)
		llenar_grid(:aux, :Fld, 'form202','Grid_1', .f.)
		Sumar_comprobante()
	End With
return

static procedure muestra_socio(odata)
	local i:= 1
	for i= 1 to len( odata:aitems )
		if rat(tostring(form202.grid_1.cell(form202.grid_1.value,3)), odata:aitems[i] ) != 0
			form202.text_5.value := 'Socio : '+ oDAta:aItems[i]
			exit
		endif
	next
return

static procedure obtener_socio(odata, nsocio)
	local i:= 1, nPos := 0
	for i= 1 to len( odata:aitems )
		if rat(tostring(form202.grid_1.cell(form202.grid_1.value,3)), odata:aitems[i] ) != 0
			nPos = i
			exit
		endif
	next
return nPos

static function obtener_responsable(nid)
	local o := Openrecordset(oConexion,"Select * from login")
	local cNombre := ""
	buscar_rs( o, 'id='+Tostring(nid))
	cNombre = o:fields('usuario'):value
	o:close()
return cNombre

static procedure imprimir(odata)
	Local r := 24
	if oData:nEdit > 0
		Msgstop('Debe salir del modo de edicin del comprobante para poder imprimir')
		return
	endif
	
	Select Printer Default Preview
	
	Start printdoc
		Start PrintPage
			M->Pagina := 0
			Titulo('INFORME DE CAJA FOLIO No '+ToString(Form202.Text_1.Value), Form202.Datepicker_1.value)
			@ r, 10 print 'Generado por : '+oUser:cName
			Subtitulos()
			r= 34
			*{'id','idMaestro','IdSocio','Boleta','Ingreso','Egreso'}
			@ 34.5, 24 PRINT LINE TO GetPrintableAreaHeight()-14.5, 24 PENWIDTH .2
			@ 34.5, 49 PRINT LINE TO GetPrintableAreaHeight()-14.5, 49 PENWIDTH .2
			@ 34.5, 99 PRINT LINE TO GetPrintableAreaHeight()-14.5, 99 PENWIDTH .2
			@ 34.5,119 PRINT LINE TO GetPrintableAreaHeight()-14.5, 119 PENWIDTH .2
			@ 34.5,139 PRINT LINE TO GetPrintableAreaHeight()-14.5, 139 PENWIDTH .2
			@ 34.5,159 PRINT LINE TO GetPrintableAreaHeight()-14.5, 159 PENWIDTH .2
			@ 34.5,179 PRINT LINE TO GetPrintableAreaHeight()-14.5, 179 PENWIDTH .2			
                                                                      			
			For i= 1 to form202.grid_1.itemcount
				@ r, 10 print ToString(i) font 'courier new' size 9
				@ r, 25 print form202.grid_1.cell(i,4) font 'courier new' size 9
				@ r, 50 print Subs(oData:aItems[ obtener_socio( odata, form202.grid_1.cell(i,3)) ],1,30) font 'courier new' size 9
				@ r,105 print Transform( form202.grid_1.cell(i,5),'999,999') font 'courier new' size 9
				@ r,125 print Transform( form202.grid_1.cell(i,6),'999,999') font 'courier new' size 9
				if buscar_rs( odata:trm, "idMaestro="+Tostring(form202.grid_1.cell(i,2))) 	
					@ r,140 print if(odata:trm:fields('cheque_num'):ActualSize= 0, "", Subs(odata:trm:fields('cheque_num'):value,1,4)) font 'courier new' size 9
					@ r,160 print if(odata:trm:fields('banco'):ActualSize=0, "", odata:trm:fields('banco'):value) font 'courier new' size 9
					@ r,180 print if(odata:trm:fields('vencimiento'):ActualSize=0, "", stod(odata:trm:fields('vencimiento'):value)) font 'courier new' size 9
					odata:trm:fields('estado'):value := 1
					odata:trm:update()				
				endif
				r+=4

				If r > GetPrintableAreaHeight()-12
						PiePagina()
						End Printpage
						Start printpage
						Titulo('INFORME DE CAJA FOLIO No '+ToString(Form202.Text_1.Value), Form202.Datepicker_1.value)
						r = 24
						@ r, 10 print 'Generado por : '+form202.text_2.Value 
						Subtitulos()
						r = 34						
				endif				
			next
			@ GetPrintableAreaHeight()-14.5, 10 PRINT LINE TO GetPrintableAreaHeight()-14.5, GetPrintableAreaWidth()-10 PENWIDTH .2
			@ GetPrintableAreaHeight()-14, 10 print 'TOTALES' font 'Courier new' size 9 bold
			@ GetPrintableAreaHeight()-14,105 print Transform( form202.text_3.value, '999,999') font 'Courier new' size 9 bold
			@ GetPrintableAreaHeight()-14,125 print Transform( form202.text_4.value, '999,999') font 'Courier new' size 9 bold
			PiePagina()
		End Printpage
	End Printdoc
	oData:Mae:fields('estado'):value := 1
	oData:Mae:update()
	Puntero(0,odata)
return

static procedure subtitulos
	@ 29.5, 10 PRINT LINE TO 29.5, GetPrintableAreaWidth()-10 PENWIDTH .2
	@ 30, 10 print "#"
	@ 30, 25 print "Boleta No"
	@ 30, 50 print "Socio"
	@ 30,100 print "Ingreso"
	@ 30,120 print "Egreso"
	@ 30,140 print "Cheque No"
	@ 30,160 print "Banco"
	@ 30,180 print "Vencto"
	@ 34, 10 PRINT LINE TO 34, GetPrintableAreaWidth()-10 PENWIDTH .2	 
return

static procedure buscar( oData )
	local cCompro := Inputbox('Buscar','Ingrese nmero de comprobante a buscar',cCompro)
	
	if len(cCompro) > 0
		if buscar_rs( odata:mae, "idCaja="+ToString(Val(cCompro)))
			Puntero(0,odata)
		else
			msgstop('No existe comprobante '+cCompro )
			buscar_rs( oData:Mae, "idCaja="+ToString(form202.text_1.value))
		endif
	endif
		
return

static procedure sumar_comprobante
	local i := 0, nIngreso := 0, nEgreso := 0
	for i= 1 to form202.grid_1.itemcount
		nIngreso	+= form202.grid_1.cell(i,5)
		nEgreso		+= form202.grid_1.cell(i,6)
	next
	form202.text_3.value	:= nIngreso
	form202.text_4.value	:= nEgreso
return

static procedure borrar_registro(odata)
	if odata:nEdit = 0
		return
	endif

	if form202.grid_1.itemcount > 0
		if form202.grid_1.value > 0
			if msgyesno('Desea eliminar este registro','Confirme')
				if form202.grid_1.cell( form202.grid_1.value, 1 ) > 0
					*- busca el registro en el auxiliar de caja
					if buscar_rs( odata:aux, "id="+tostring(form202.grid_1.cell(form202.grid_1.value, 1)))					
						*- busca el registro en el archivo de comprobantes y lo libera.
						if buscar_rs( odata:trm, "idMaestro="+Tostring(odata:aux:fields('idmaestro'):value))
							odata:trm:fields('estado'):value := 0
							odata:trm:update()
						endif						
						odata:aux:delete()
						odata:aux:update()
					endif
				endif
				form202.grid_1.deleteitem( form202.grid_1.value )
				sumar_comprobante()
				form202.grid_1.setfocus
			endif
		endif
	endif
return

static procedure borrar(odata)
	if odata:mae:recordcount > 0
		if odata:mae:fields('estado'):value > 0
			if Msgyesno('Desea eliminar este comprobante','Confirmar')	
				if oData:Aux:recordcount > 0
					oData:aux:Movefirst()
					do while !odata:aux:eof()
						odata:aux:delete()
						odata:aux:movenext()
					enddo
					odata:aux:update()
				endif
				odata:mae:delete()
				odata:mae:update()
				puntero(2,odata)
			endif
		else
			Msgstop('No es posible eliminar este documento')
		endif
	endif	
return

static procedure cerrar(odata)	
	odata:mae:close()
	odata:aux:close()
	odata:trm:close()
	odata:tra:close()
	odata:soc:close()
	odata:release()
return

static procedure cerrar_comprobante(odata)
	Local nId :=0, i := 1
	Try
		With Object oData
			*- Graba encabezado del comprobante de caja
			if form202.Text_1.Value = 0
				:mae:AddNew()
				:mae:fields('fecha_emision'):Value 	:= dtos(form202.Datepicker_1.Value)
			else
				buscar_rs(:mae, "idCaja="+ToString(form202.text_1.value))
				nId = :Mae:Fields('idcaja'):value
			endif
			:mae:fields('idResponsable'):Value 	:= oUser:nId
			:mae:fields('ingresos'):Value		:= form202.text_3.value
			:mae:fields('egresos'):value		:= form202.text_4.value
			:mae:fields('estado'):Value			:= 0
			:mae:fields('usuario'):value		:= oUser:cUser
			:mae:fields('hora'):value			:= Time()
			:mae:Update()
			if nId = 0
				:mae:Requery()
				:mae:MoveLast()
				nId := :mae:Fields('idCaja'):value
			endif
			form202.text_1.value := nId
			
			*- Graba detalle del comprobante.
			for i = 1 to form202.grid_1.itemcount
				if form202.grid_1.cell(i,1) = 0
					:aux:AddNew()
				else
					buscar_rs(:aux, "id="+Tostring(form202.grid_1.cell(i,1)))
				endif
				*{'id','idMaestro','IdSocio','Boleta','Ingreso','Egreso'}
    	
				:aux:fields('idCaja'):value		:= nId
				:aux:fields('idMaestro'):value	:= form202.grid_1.cell(i,2)
				:aux:fields('idsocio'):value	:= form202.grid_1.cell(i,3)
				:aux:fields('boleta'):value		:= form202.grid_1.cell(i,4)
				:aux:fields('ingreso'):value	:= form202.grid_1.cell(i,5)
				:aux:fields('egreso'):value		:= form202.grid_1.cell(i,6)
				:aux:update()	
				if buscar_rs(:trm, "idMaestro="+ToString(form202.grid_1.cell(i,2)))
					*- Cambia el estado a Cerrado para que no lo vayan a modificar.
					*- en cuyo caso se producir inconsistencia de datos.
					:Trm:Fields('Estado'):Value := 1
					:Trm:update()
				endif
			next
			:nEdit	:= 0
		End With
	Catch e
		MsgStop("Operacin: "+e:operation+hb_osnewline()+"Descripcin: "+e:Description)	
		form202.release
	End Try
	estado_control(0,odata)
	Muestra_datos(odata)
return

static procedure Seleccionar_comprobantes(odata)
	if odata:nEdit = 0
		return
	endif
	load window form202a
	form202a.center
	form202a.datepicker_1.value	:= form202.datepicker_1.value
	activate window form202a
return

static procedure filtrar_comprobante(odata)
	local nIngreso, nEgreso
	local o 
	Form202a.grid_1.deleteallitems
	With Object oData
		o = OpenRecordset( oConexion, "Select * from Transaccionesmaestro where fecha_emision = '"+dtos(form202a.datepicker_1.value)+"'" )
		if o:recordcount > 0
			o:MoveFirst()
			do while !o:eof()
				nIngreso= 0
				nEgreso	= 0
				:Tra:Filter="IdMaestro="+ToString(o:fields('IdMaestro'):value)				
				if :Tra:Recordcount > 0
					:Tra:MoveFirst()
					do while !:Tra:eof()
						nIngreso+= :Tra:fields('ingreso'):value
						nEgreso	+= :Tra:fields('egreso'):value
						:Tra:Movenext()
					enddo
				endif
						
				form202a.grid_1.additem( { 	ToString(o:fields('idMaestro'):value),;
											ToString(o:fields('idsocio'):value),;
											o:fields('glosa'):value,;
											tostring(o:fields('boleta'):value),;
											Str(nIngreso),;
											Str(nEgreso) })
				o:MoveNext()											
			enddo
		endif
		o:close()
		Form202a.grid_1.Setfocus
	End With
return

static procedure traspasar_comprobantes_seleccionados
	local i := 1
	*{'id','idMaestro','IdSocio','Boleta','Ingreso','Egreso'}
	for i= 1 to form202.grid_1.itemcount
		if form202.grid_1.cell(i,1) = 0
			form202.grid_1.deleteitem(i)
		endif
	next
	For i= 1 to Len(form202a.grid_1.Value)
		form202.grid_1.additem({0,;
								val(form202a.grid_1.cell(form202a.grid_1.value[i],1)),;
								val(form202a.grid_1.cell(form202a.grid_1.value[i],2)),;
								val(form202a.grid_1.cell(form202a.grid_1.value[i],4)),;
								val(form202a.grid_1.cell(form202a.grid_1.value[i],5)),;
								val(form202a.grid_1.cell(form202a.grid_1.value[i],6))})
	Next
	form202a.release
	sumar_comprobante()
return

static function carga_socios(soc)
	local atemp:= {}
	if soc:recordcount > 0
		soc:Movefirst()
		do while !soc:eof()
			aadd( atemp, ToString(soc:fields('idSocio'):value)+'-'+soc:fields('nombres'):value+' '+soc:fields('paterno'):value )
			soc:movenext()
		enddo
		Soc:MoveFirst()
	endif
return atemp